"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: December 01, 2023
Version: 1.0.0
Description: Explanation module of expert system, getting and printing result to the user
"""

import KomunikacniModul


def print_results(results):
    """
    Printing all results
    :param results: solutions of Einstein riddle
    """
    print(KomunikacniModul.number_of_solutions(len(results)))
    for i in range(len(results)):
        print(KomunikacniModul.result_number(i + 1))
        print_table(results[i])


def print_table(table: [str]):
    """
    Printing one result to the table
    :param table: one solution in list
    """
    print(20 * 6 * "-" + "-")
    for row in range(len(table)):
        print(f"|{KomunikacniModul.headers[row]}".ljust(20), end="")
        for col in table[row]:
            print(f"|{col}".ljust(20), end="")
        print('|')
    print(20 * 6 * "-" + "-")
