"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: December 01, 2023
Version: 1.0.0
Description: Inference module of expert system, getting user choices
"""

from BazeDat import known_facts
from BazeZnalosti import rules
from VysvetlovaciModul import print_result
import KomunikacniModul


def app():
    """
    Controlling of the app
    """
    print(KomunikacniModul.welcome_message)
    print(KomunikacniModul.rules)
    print(KomunikacniModul.line)
    print(KomunikacniModul.facts)
    print(KomunikacniModul.line)
    print(KomunikacniModul.show_results, end="")
    input()
    print(KomunikacniModul.line)
    use_rules()
    print_result()
    print(KomunikacniModul.line)
    print(KomunikacniModul.end_program, end="")
    input()


def use_rules():
    """
    Function Inffering the result from the facts and rules
    """
    used_rules = []
    known_facts_changed = True

    while len(used_rules) < len(rules) and known_facts_changed:
        known_facts_changed = False
        for rule in rules:
            if rule not in used_rules:
                if len(rule) == 3:
                    if rule[0] in known_facts and rule[1] in known_facts:
                        known_facts.append(rule[2])
                        used_rules.append(rule)
                        known_facts_changed = True
                else:
                    if rule[0] in known_facts:
                        known_facts.append(rule[1])
                        used_rules.append(rule)
                        known_facts_changed = True
