"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: December 01, 2023
Version: 1.0.0
Description: Communication module, this module contains all strings what can be print to the user
"""

welcome_message = f"Vítejte v programu pro řešení modifikované Einsteinovy hádanky.\nÚloha zní následovně:"

einstein_riddle = "Existuje pět domů, přičemž každý má odlišnou barvu.\n" \
                  "V každém domě žije osoba odlišné národnosti.\n" \
                  "Každý z těchto pěti obyvatel pije svůj vlastní nápoj, kouří svou značku cigaret a chová své oblíbené zvíře.\n" \
                  "Nikdo nepije to, co pijí ostatní, nekouří stejnou značku cigaret jako ostatní a nechová stejné zvíře jako ostatní."

rules = "Platí následující fakta:\n" \
        "1) Angličané žijí v červeném domě.\n" \
        "2) Španělé mají psa.\n" \
        "3) Norové žijí v prvém domě zleva.\n" \
        "4) Obyvatelé žlutého domu kouří sparty.\n" \
        "5) Muž, který kouří Chesterfieldky, žije v domě vedle domu rodiny, která chová lišku.\n" \
        "6) Norové žijí v modrém domě.\n" \
        "7) Kuřák Winstonek chová šneky.\n" \
        "8) Kuřák Lucky-Strike pije pomerančový džus.\n" \
        "9) Ukrajinci pijí čaj.\n" \
        "10) Japonci kouří cigarety značky Parliaments.\n" \
        "11) V domě vedle domu s koněm se kouří sparty.\n" \
        "12) V zeleném domě pijí kávu.\n" \
        "13) Zelený dům je bezprostředně napravo od bílého domu.\n" \
        "14) V prostředním domu pijí mléko."

press_enter = "Pro řešení hádánky stiskněte ENTER ..."

no_solution = "Úloha nemá řesení."

close_program = "Pro ukončení programu zmáčkněte ENTER ..."

line = "---------------------------------------------------------------------------------------------------------------"

headers = ["Dům", "Barva", "Národnost", "Nápoj", "Cigarety", "Domácí mazlíček"]


def number_of_solutions(number: int) -> str:
    """
    Creating text for numbers of solutions
    :param number: number of solutions
    :return: created text
    """
    return f"Hádanka má {number} řešení."


def result_number(number: int) -> str:
    """
    Creating text for each result
    :param number: number of actual result
    :return: created text
    """
    return f"Řešení číslo {number}:"
