"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: November 29, 2023
Version: 1.0.0
Description: Inference module of expert system, getting user choices
"""
from BazeZnalosti import AndORGraph
from VysvetlovaciModul import draw_tree, print_children
from BazeDat import data
import KomunikacniModul


def app():
    """
    Application, main point of the program
    """
    print(KomunikacniModul.welcome_text)
    and_or_graph = AndORGraph("Pokrm")
    and_or_graph.create_tree(data)
    print(KomunikacniModul.line)
    user_input = ""
    while user_input != "3":
        print(KomunikacniModul.question)
        print(KomunikacniModul.choice_text, end="")
        user_input = input()
        print(KomunikacniModul.line)
        chose_method(user_input, and_or_graph)


def chose_method(user_input: str, graph):
    """
    Selector of methods
    :param user_input: input form user
    :param graph: AND/OR graph
    """
    if user_input == "1":
        draw_tree(graph.root)
        print(KomunikacniModul.enter_to_continue)
        input()
    elif user_input == "2":
        chose_node(graph)
    elif user_input != "3":
        print(KomunikacniModul.invalid_input)


def chose_node(graph):
    """
    Selector which meal will be described
    :param graph: AND/OR graph
    """
    input_valid = False
    while not input_valid:
        print(KomunikacniModul.choice_food, end = "")
        user_input = input()
        print(KomunikacniModul.line)
        if user_input == "1":
            print_children(graph, "Lasagne verde")
            input_valid = True
        elif user_input == "2":
            print_children(graph, "Boloňské špagety")
            input_valid = True
        elif user_input == "3":
            print_children(graph, "Neapolské špagety")
            input_valid = True
        elif user_input == "4":
            print_children(graph, "Boloňská omáčka")
            input_valid = True
        elif user_input == "5":
            input_valid = True
        else:
            print(KomunikacniModul.invalid_input)
