"""
@author Vitaliy Bohera
@version 1
@info Vysvetlovaci modul znalostniho systemu pro reseni einsteinovy ulohy (jedno reseni)
@date 8.12.2023
"""
import znalosti

'''
Funckce vypise formatovany radek pro dany typ
@param typ - Dum, Barva, Napoj, Kouri, Zvire, Narodnost
@param data - usporadani prvku pro dane reseni
'''


def vypis_radek(typ, data):
    print("{:15s}|{:<15s}|{:<15s}|{:<15s}|{:<15s}|{:<15s}".format(typ.__name__, typ.prvky[data[0]],
                                                                  typ.prvky[data[1]], typ.prvky[data[2]],
                                                                  typ.prvky[data[3]], typ.prvky[data[4]]))


'''
Funkce vypise vsechna reseni Einsteinovy ulohy
'''


def vypis_reseni():
    reseni = znalosti.zjisti_reseni()
    for key, value in reseni.items():
        print("Reseni cislo: " + str(key) + "\n")
        for typ, data in value.items():
            vypis_radek(typ, data)
        print("--------------------------------------------------------------------------------------")
