# Autor: Lukas Sobotka
# Datum: 15. 12. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani jednotlivych pravidel nad daty
# ------------------------------------------------------------------------------------------------


# Zadana pravidla

# Anglicane ziji v cervenem dome
def pravidlo1(domy):
    if [dum.narodnost for dum in domy if dum.barva == "cervena"][0] != "anglican":
        return False
    return True


# spanele maji psa
def pravidlo2(domy):
    if [dum.chova for dum in domy if dum.narodnost == "spanel"][0] != "pes":
        return False
    return True


# Norove ziji v prvnim dome zleva
def pravidlo3(domy):
    if domy[0].narodnost != "norove":
        return False
    return True


# Obyvatele zluteho domu kouri sparty
def pravidlo4(domy):
    if [dum.kouri for dum in domy if dum.barva == "zluta"][0] != "sparty":
        return False
    return True


# Muz, ktery kouri Chesterfieldky, zije v dome vedle domu rodiny, ktera chova lisku
def pravidlo5(domy):
    chesterfield = [domy.index(dum) for dum in domy if dum.kouri == "chesterfield"][0]
    liska = [domy.index(dum) for dum in domy if dum.chova
             == "liska"][0]

    if abs(chesterfield - liska) != 1:
        return False
    return True


# Norove ziji v modrem domu
def pravidlo6(domy):
    if [dum.barva for dum in domy if dum.narodnost == "norove"][0] != "modra":
        return False
    return True


# Kurak Windstonek pestuje sneky
def pravidlo7(domy):
    if [dum.chova for dum in domy if dum.kouri == "windston"][0] != "snek":
        return False
    return True


# Kurak Lucky-Strike pije pomerancovy dzus
def pravidlo8(domy):
    if [dum.pije for dum in domy if dum.kouri == "lucky-strike"][0] != "dzus":
        return False
    return True


# Ukrajinci piji caj
def pravidlo9(domy):
    if [dum.pije for dum in domy if dum.narodnost == "ukrajinci"][0] != "caj":
        return False
    return True


# Japonci kouri cigarety znacky Parliaments
def pravidlo10(domy):
    if [dum.kouri for dum in domy if dum.narodnost == "japonci"][0] != "parliaments":
        return False
    return True


# V dome vedle domu s konem se kouri sparty
def pravidlo11(domy):
    sparty = [domy.index(dum) for dum in domy if dum.kouri == "sparty"][0]
    kun = [domy.index(dum) for dum in domy if dum.chova
           == "kun"][0]

    if abs(sparty - kun) != 1:
        return False
    return True


# V zelenem dome piji kavu
def pravidlo12(domy):
    if [dum.pije for dum in domy if dum.barva == "zelena"][0] != "kava":
        return False
    return True


# Zeleny dum je bezprostredne napravo od bileho
def pravidlo13(domy):
    zeleny = [domy.index(dum) for dum in domy if dum.barva == "zelena"][0]
    bily = [domy.index(dum) for dum in domy if dum.barva == "bila"][0]
    if zeleny != bily + 1:
        return False
    return True


# V prostrednim domu piji mleko
def pravidlo14(domy):
    if domy[2].pije != "mleko":
        return False
    return True
