# Autor: Lukas Sobotka
# Datum: 15. 12. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro vysvetleni dat a jejich vypsani uzivateli
# ------------------------------------------------------------------------------------------------
import baze_znalosti as znalosti


# vypise vsechny dostupne pokrmy
def vypis_pokrmy():
    pokrmy = znalosti.dostupne_pokrmy()
    print("------------------------------------------------------------------------------------------------")
    print("Dostupne pokrmy:")
    for pokrm in pokrmy:
        print("- " + pokrm)
    print("------------------------------------------------------------------------------------------------")


# vypise ingredience daneho pokrmu
def vypis_ingredience_pokrmu(pokrm):
    obsah = znalosti.obsah_pokrmu(pokrm)
    print("------------------------------------------------------------------------------------------------")
    print(pokrm + " jsou slozeny z techto ingedieci: ")
    for ingredience in obsah:
        print("- " + ingredience)
    print("------------------------------------------------------------------------------------------------")


# vypise graf i s hlavickou a patickou
# uzel - uzly vypisovaneho grafu
def vypis_cely_graf(uzly):
    print("------------------------------------------------------------------------------------------------")
    vypis_sekci_grafu(uzly)
    print("------------------------------------------------------------------------------------------------")


# Vypise sekci grafu a rekurzivnim volanim i vsechny nizsi sekce
# uzel - uzly vypisovaneho grafu
# odsazeni - jake odsazeni bude mit aktualne vypisovana sekce grafu
def vypis_sekci_grafu(uzly, odsazeni=0):
    #
    if isinstance(uzly, dict):
        for key, value in uzly.items():
            print("     " * odsazeni + f"- {key}")
            vypis_sekci_grafu(value, odsazeni + 1)
    elif isinstance(uzly, list):
        for item in uzly:
            vypis_sekci_grafu(item, odsazeni)
    else:
        print("     " * odsazeni + f"- {uzly}")
