# Autor: Lukas Sobotka
# Datum: 15. 12. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro rizeni celeho projektu, pouziva funkci komunikacniho modulu pro komunikaci s uzivatelem
# ------------------------------------------------------------------------------------------------

import komunikacni_modul as kom
import baze_znalosti as znalosti
import baze_dat as data


# Hlavni funkce systemu
def start():
    kom.vypis_uvod()
    vysledek = odvozuj()
    if vysledek is None:
        kom.vypis_nelze()
    kom.vypis_vysledek(vysledek)

# uplatnuje odvozovaci pravidla a vraci zaver, ke kteemu dojde
# zaver odvozeny z pravidel
def odvozuj():
    fakta = data.fakta
    pouzite_podminky = []

    stara_fakta = {}
    # odvozovani opakujeme dokud nezbyde jen zaver
    while len(fakta) != 1:

        # pokud se fakta nezmenila => zaver nelze odvodit
        if stara_fakta == fakta:
            return None
        stara_fakta = fakta

        for zaver_pravidla, podminky_pravidla in znalosti.odvozovaci_pravidla.items():
            for podminka in podminky_pravidla:
                # pokud podminka neni ve faktech, nelze pravidlo pouzit
                if podminka not in fakta:
                    pouzite_podminky.clear()
                    break
                pouzite_podminky.append(podminka)
            fakta = list(set(fakta) - set(pouzite_podminky))
            fakta.append(zaver_pravidla)

    return fakta[0]