# Autor: Lukas Sobotka
# Datum: 15. 12. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani jednotlivych pravidel nad daty
# ------------------------------------------------------------------------------------------------

# Zadana pravidla

# Anglican zije v cervenem dome
def pravidlo1(domy):
    if [dum.narodnost for dum in domy if dum.barva == "cervena"][0] != "anglican":
        return False
    return True


# Sved chova psy.
def pravidlo2(domy):
    if [dum.chova for dum in domy if dum.narodnost == "sved"][0] != "pes":
        return False
    return True


# V zelenem dome piji kavu
def pravidlo3(domy):
    if [dum.pije for dum in domy if dum.barva == "zelena"][0] != "kava":
        return False
    return True


# Dan pije caj
def pravidlo4(domy):
    if [dum.pije for dum in domy if dum.narodnost == "dan"][0] != "caj":
        return False
    return True


# Zeleny dum je hned vedle bileho domu na leve strane.
def pravidlo5(domy):
    zeleny = [domy.index(dum) for dum in domy if dum.barva == "zelena"][0]
    bily = [domy.index(dum) for dum in domy if dum.barva == "bila"][0]
    if zeleny != bily -1:
        return False
    return True


# Ten, co kouri Pall Mall, chova ptaky.
def pravidlo6(domy):
    if [dum.chova for dum in domy if dum.kouri == "pall mall"][0] != "ptak":
        return False
    return True


# Obyvatel zluteho domu kouri Dunhill.
def pravidlo7(domy):
    if [dum.kouri for dum in domy if dum.barva == "zluta"][0] != "dunhill":
        return False
    return True


# Ten, co zije ve strednim dome pije mleko.
def pravidlo8(domy):
    if domy[2].pije != "mleko":
        return False
    return True


# Nor zije v prvnim dome.
def pravidlo9(domy):
    if domy[0].narodnost != "nor":
        return False
    return True


# Ten, co kouri Blend zije vedle toho, kdo chova kocky.
def pravidlo10(domy):
    blend = [domy.index(dum) for dum in domy if dum.kouri == "blend"][0]
    kocka = [domy.index(dum) for dum in domy if dum.chova == "kocka"][0]

    if abs(blend - kocka) != 1:
        return False
    return True


# Ten, co chova kone zije vedle toho, kdo kouri Dunhill.
def pravidlo11(domy):
    dunhill = [domy.index(dum) for dum in domy if dum.kouri == "dunhill"][0]
    kun = [domy.index(dum) for dum in domy if dum.chova == "kun"][0]

    if abs(dunhill - kun) != 1:
        return False
    return True


# Ten, co kouri Blue Master pije pivo.
def pravidlo12(domy):
    if [dum.pije for dum in domy if dum.kouri == "blue master"][0] != "pivo":
        return False
    return True


# Nemec kouri Prince.
def pravidlo13(domy):
    if [dum.kouri for dum in domy if dum.narodnost == "nemec"][0] != "prince":
        return False
    return True


# Nor zije vedle modreho domu.
def pravidlo14(domy):
    nor = [domy.index(dum) for dum in domy if dum.narodnost == "nor"][0]
    modra = [domy.index(dum) for dum in domy if dum.barva == "modra"][0]

    if abs(nor - modra) != 1:
        return False
    return True


# Ten, co kouri Blend ma souseda, ktery pije vodu.
def pravidlo15(domy):
    blend = [domy.index(dum) for dum in domy if dum.kouri == "blend"][0]
    voda = [domy.index(dum) for dum in domy if dum.pije == "voda"][0]

    if abs(blend - voda) != 1:
        return False
    return True