# Autor: Lukas Sobotka
# Datum: 15. 12. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro rizeni celeho projektu, pouziva funkci komunikacniho modulu pro komunikaci s uzivatelem
# ------------------------------------------------------------------------------------------------

from baze_znalosti import *
from baze_dat import *
from komunikacni_modul import *


# Hlavni funkce celeho programu
def start():
    vypis_uvod()
    vysledek = vyres()
    vypis_vysledek(vysledek)


# Vytvori vsechny mozne permutace pro zadany seznam
def ziskej_permutace(seznam):
    if len(seznam) == 1:
        return [seznam]
    else:
        seznam_permutaci = []
        for prvek in seznam:
            list_temp = [x for x in seznam if prvek != x]
            perm = ziskej_permutace(list_temp)
            for p in perm:
                seznam_permutaci.append([prvek] + p)
        return seznam_permutaci


# Pro vsechny domy zkontroluje dodrzeni pravidel
def check(domy):
    if len(domy) != 5:
        return False

    if not pravidlo1(domy):
        return False

    if not pravidlo2(domy):
        return False

    if not pravidlo3(domy):
        return False

    if not pravidlo4(domy):
        return False

    if not pravidlo5(domy):
        return False

    if not pravidlo6(domy):
        return False

    if not pravidlo7(domy):
        return False

    if not pravidlo8(domy):
        return False

    if not pravidlo9(domy):
        return False

    if not pravidlo10(domy):
        return False

    if not pravidlo11(domy):
        return False

    if not pravidlo12(domy):
        return False

    if not pravidlo13(domy):
        return False

    if not pravidlo14(domy):
        return False

    if not pravidlo15(domy):
        return False

    return True


# Vyresi ulohu vytvorenim vsech permutaci a pak kontrolou dodrzeni pravidel
def vyres():
    #
    seznam_napoju = ziskej_permutace(napoje)
    seznam_napoju = [list for list in seznam_napoju if (list[2] == "mleko")]
    seznam_zemi = ziskej_permutace(narody)
    seznam_zemi = [list for list in seznam_zemi if list[0] == "nor"]
    seznam_cigaret = ziskej_permutace(cigarety)
    seznam_cigaret = [list for list in seznam_cigaret if list[0] == "dunhill"]
    seznam_barev = ziskej_permutace(barvy)
    seznam_barev = [list for list in seznam_barev if list[0] == "zluta" and list[1] == "modra"]
    seznam_zvirat = ziskej_permutace(zvirata)

    # Prochazeni permutaci
    napoj = 0
    for nap in seznam_napoju:
        napoj += 1
        zeme = 0
        for zem in seznam_zemi:
            zeme += 1
            cigareta = 0
            for cig in seznam_cigaret:
                cigareta += 1
                barva = 0
                for bar in seznam_barev:
                    barva += 1
                    zvire = 0
                    for zvi in seznam_zvirat:
                        zvire += 1

                        domy = []
                        for i in range(0, 5):
                            domy.append(Dum(bar[i], zem[i], nap[i], cig[i], zvi[i]))

                        # Kontrola pro vsechny domy
                        if check(domy):
                            vysledek = [["", "", "", "", ""], ["", "", "", "", ""], ["", "", "", "", ""],
                                ["", "", "", "", ""], ["", "", "", "", ""]]

                            i = 0
                            for dum in domy:
                                vysledek[0][i] = dum.barva
                                vysledek[1][i] = dum.narodnost
                                vysledek[2][i] = dum.kouri
                                vysledek[3][i] = dum.pije
                                vysledek[4][i] = dum.chova
                                i += 1

                            return vysledek
