"""
@author Vitaliy Bohera
@version 1
@info Vysvetlovaci modul pravidloveho systemu pro reprezentaci pokrmu
@date 8.12.2023
"""
import znalosti

'''
Funckce vypise formatovany radek pro dany typ
@param typ - Dum, Barva, Napoj, Kouri, Zvire, Narodnost
@param data - usporadani prvku pro dane reseni
'''


# funkce vypise vsechny dostupne pokrmy
def vypis_pokrmy():
    pokrmy = znalosti.dostupne_pokrmy()
    print("---------------------")
    print("Dostupne pokrmy:")
    for pokrm in pokrmy:
        print("- " + pokrm)
    print("---------------------")


# funkce vypise vsechny dostupne omacky
def vypis_omacky():
    omacky = znalosti.dostupne_omacky()
    print("---------------------")
    print("Dostupne omacky:")
    for omacka in omacky:
        print("- " + omacka)
    print("---------------------")


# funkce vypise obsah daneho pokrmu
def vypis_obsah_pokrmu(pokrm):
    obsah = znalosti.obsah_pokrmu(pokrm)
    print("----------------------------------")
    print(pokrm + " se skladaji z: ")
    for ingredience in obsah:
        print("- " + ingredience)
    print("----------------------------------")


# funkce vypise obsah dane omacky
def vypis_obsah_omacky(omacka):
    obsah = znalosti.obsah_omacky(omacka)
    print("----------------------------------")
    print(omacka + " se sklada z: ")
    if len(obsah) == 0:
        print("System neobsahuje pozadovane informace.")
    else:
        for ingredience in obsah:
            print("- " + ingredience)
    print("----------------------------------")


# funkce vypise upraveny graf pokrmu
def vypis_uparaveny_graf(uzel):
    print("----------------------------------")
    print("Graf pokrmu: ")
    vypis_graf(uzel)
    print("----------------------------------")


# funkce vypise graf pokrmu
def vypis_graf(uzel, indent=0):
    if isinstance(uzel, dict):
        for key, value in uzel.items():
            print("     " * indent + f"+ {key}")
            vypis_graf(value, indent + 1)
    elif isinstance(uzel, list):
        for item in uzel:
            vypis_graf(item, indent)
    else:
        print("     " * indent + f"- {uzel}")