"""
Description: Tento modul ukládá a poskytuje data.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 12.12.2023
"""


class House:
    """
    Obsahuje informace o domu a jeho obyvatelich
    """
    def __init__(self, house_num, color, nationality, drink, cigarette, pet):
        """
        Konstruktor objektu dum
        :param house_num: cislo domu
        :param color: barva domu
        :param nationality: narodnost obyvatele
        :param drink: napoj obyvatele
        :param cigarette: cigarety obyvatele
        :param pet: zvire obyvatele
        """
        self.house_num = house_num
        self.color = color
        self.nationality = nationality
        self.drink = drink
        self.cigarette = cigarette
        self.pet = pet


# pripraveny seznam k naplneni spravnymi kombinacemi
houses = [House(1, None, None, None, None, None), House(2, None, None, None, None, None),
          House(3, None, None, None, None, None), House(4, None, None, None, None, None),
          House(5, None, None, None, None, None)]

# seznamy obsahujici moznosti barev, narodnosti, napoju, cigaret a mazlicku
house_nums = ["1", "2", "3", "4", "5"]
colors = ["Červená", "Zelená", "Bílá", "Modrá", "Žlutá"]
nationalities = ["Angličan", "Švéd", "Dán", "Nor", "Němec"]
drinks = ["Čaj", "Káva", "Mléko", "Pivo", "Voda"]
cigarettes = ["Pall Mall", "Dunhill", "Blend", "Blue Master", "Prince"]
pets = ["Pes", "Pták", "Kočka", "Kůň", "Ryba"]


class Remaining:
    """
    Obsahuje seznamy zbyvajicich prvku pro jednotlive moznosti
    """
    def __init__(self, colors, nationalities, drinks, cigarettes, pets):
        """
        Konstruktor objektu "zbyvajici"
        :param colors: seznam zbyvajicich barev
        :param nationalities: seznam zbyvajicich narodnosti
        :param drinks: seznam zbyvajicich napoju
        :param cigarettes: seznam zbyvajicich cigaret
        :param pets: seznam zbyvajicich zvirat
        """
        self.colors = colors
        self.nationalities = nationalities
        self.drinks = drinks
        self.cigarettes = cigarettes
        self.pets = pets


# uchovava zbyvajici moznosti
remaining = Remaining(colors, nationalities, drinks, cigarettes, pets)
