"""
Description: Tento modul ukládá a poskytuje znalosti.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 12.12.2023
"""


def verify_rules(houses):
    # kontroluje zda seznam "houses" odpovida zadanym pravidlum
    for house in houses:
        if house.nationality == "Angličan":
            # Anglican zije v cervenem dome.
            if house.color is not None and house.color != "Červená":
                return False
        elif house.nationality == "Švéd":
            # Sved chova psy.
            if house.pet is not None and house.pet != "Pes":
                return False
        elif house.nationality == "Dán":
            # Dan pije caj.
            if house.drink is not None and house.drink != "Čaj":
                return False
        elif house.nationality == "Nor":
            # Nor zije v prvnim dome.
            if house.house_num != 1:
                return False
            # Nor zije vedle modreho domu.
            possible = False
            if house.house_num > 1 and (
                    houses[house.house_num-2].color is None or
                    houses[house.house_num-2].color == "Modrá"):
                possible = True
            elif house.house_num < 5 and (
                    houses[house.house_num].color is None or
                    houses[house.house_num].color == "Modrá"):
                possible = True
            if not possible:
                return False
        elif house.nationality == "Němec":
            # Nemec kouri Prince.
            if house.cigarette is not None and house.cigarette != "Prince":
                return False

        if house.cigarette == "Dunhill":
            # Obyvatel zluteho domu kouri Dunhill.
            if house.color is not None and house.color != "Žlutá":
                return False
            # Ten, co chova kone, zije vedle toho, co kouri Dunhill.
            possible = False
            if house.house_num > 1 and (
                    houses[house.house_num - 2].pet is None or
                    houses[house.house_num - 2].pet == "Kůň"):
                possible = True
            elif house.house_num < 5 and (
                    houses[house.house_num].pet is None or
                    houses[house.house_num].pet == "Kůň"):
                possible = True
            if not possible:
                return False
        elif house.cigarette == "Pall Mall":
            # Ten, co kouri Pall Mall, chova ptaky.
            if house.pet is not None and house.pet != "Pták":
                return False
        elif house.cigarette == "Blend":
            # Ten, co kouri Blend, zije vedle toho, co chova kocky.
            possible = False
            if house.house_num > 1 and (
                    houses[house.house_num - 2].pet is None or
                    houses[house.house_num - 2].pet == "Kočka"):
                possible = True
            elif house.house_num < 5 and (
                    houses[house.house_num].pet is None or
                    houses[house.house_num].pet == "Kočka"):
                possible = True
            if not possible:
                return False
            # Ten, co kouri Blend, ma souseda, ktery pije vodu.
            possible = False
            if house.house_num > 1 and (
                    houses[house.house_num - 2].drink is None or
                    houses[house.house_num - 2].drink == "Voda"):
                possible = True
            elif house.house_num < 5 and (
                    houses[house.house_num].drink is None or
                    houses[house.house_num].drink == "Voda"):
                possible = True
            if not possible:
                return False
        elif house.cigarette == "Blue Master":
            # Ten, co kouri Blue Master, pije pivo.
            if house.drink is not None and house.drink != "Pivo":
                return False

        if house.drink == "Káva":
            # Obyvatel zeleneho domu pije kavu.
            if house.color is not None and house.color != "Zelená":
                return False
        elif house.drink == "Mléko":
            # Ten, co zije ve strednim dome, pije mleko.
            if house.house_num != 3:
                return False

        if house.color == "Zelená":
            # Zeleny house je hned vedle bileho domu na leve strane.
            if house.house_num == 5 or (houses[house.house_num].color is not None
                                        and houses[house.house_num].color != "Bílá"):
                return False
    return True
