"""
Description: Tento modul ukládá a poskytuje znalosti.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 12.12.2023
"""


def verify_rules(houses):
    # ocekava houses jako seznam objektu "house" o delce 5
    # house.house_num = 1   # prvni zleva, postupne zvysujeme
    for house in houses:
        if house.nationality == "Angličané":
            # Anglican zije v cervenem dome.
            if house.color is not None and house.color != "Červená":
                return False
        elif house.nationality == "Španělé":
            # Sved chova psy.
            if house.pet is not None and house.pet != "Pes":
                return False
        elif house.nationality == "Norové":
            # Norove ziji v prvem dome zleva
            if house.house_num != 1:
                return False
            # Norove ziji v modrem domu
            if house.color is not None and house.color != "Modrá":
                return False
        elif house.nationality == "Ukrajinci":
            # Ukrajinci piji caj
            if house.drink is not None and house.drink != "Čaj":
                return False
        elif house.nationality == "Japonci":
            # Japonci kouri cigarety znacky Parliaments
            if house.cigarette is not None and house.cigarette != "Parliaments":
                return False

        if house.cigarette == "Sparta":
            # Obyvatele zluteho domu kouri sparty
            if house.color is not None and house.color != "Žlutá":
                return False
            # V dome vedle domu s konem se kouri sparty
            possible = False
            if house.house_num > 1 and (
                    houses[house.house_num - 2].pet is None or
                    houses[house.house_num - 2].pet == "Kůň"):
                possible = True
            elif house.house_num < 5 and ( # elif house...
                    houses[house.house_num].pet is None or
                    houses[house.house_num].pet == "Kůň"):
                possible = True
            if not possible:
                return False

        elif house.cigarette == "Chesterfield":
            # Muz, ktery kouri Chesterfieldky, zije v dome vedle domu rodiny, ktera chova lisku
            possible = False
            if house.house_num > 1 and (
                    houses[house.house_num - 2].pet is None or
                    houses[house.house_num - 2].pet == "Liška"):
                possible = True
            elif house.house_num < 5 and (
                    houses[house.house_num].pet is None or
                    houses[house.house_num].pet == "Liška"):
                possible = True
            if not possible:
                return False

        elif house.cigarette == "Winston":
            # Kurak Winstonek pestuje sneky
            if house.pet is not None and house.pet != "Šnek":
                return False
        elif house.cigarette == "Lucky-Strike":
            # Kurak Lucky-Strike pije pomerancovy dzus
            if house.drink is not None and house.drink != "Pomerančový džus":
                return False

        if house.color == "Zelená":
            # Zeleny house je hned vedle bileho domu na leve strane.
            if house.drink is not None and house.drink != "Káva":
                return False
            if house.house_num == 1 or (
                    houses[house.house_num-2].color is not None and
                    houses[house.house_num-2].color != "Bílá"):
                return False

        if house.house_num == 3:
            # V prostrednim domu piji mleko
            if house.drink is not None and house.drink != "Mléko":
                return False
    return True
