"""
Description: Tento modul řídí běh znalostního systému.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.12.2023
"""
import baze_znalosti
from baze_dat import facts
import komunikacni_modul
import vysvetlovaci_modul


def start():
    # tato metoda spousti znalostni system
    komunikacni_modul.start_info()
    solve()
    komunikacni_modul.end_info()


def solve():
    # metoda ktera hleda zaver pomoci faktu a pravidel
    known_facts = facts.copy()
    rules = baze_znalosti.rules.copy()
    rules_changed = rules.copy()

    while len(rules) != 0:
        # dokud nevyuzijeme vsechna pravidla bude cyklus pokracovat
        for rule in rules:
            if len(rule) == 2:
                # pro pravidla s jednim prvkem na leve strane
                if rule[0] in known_facts:
                    # pokud jsou splneny podminky pravidla prida se nove odvozeny fakt a odebere se pravidlo
                    # ktere k tomu bylo pouzito
                    known_facts.append(rules_changed.pop(rules_changed.index(rule))[1])
            else:
                # pro pravidla s dvema prvky na leve strane
                if (rule[0] in known_facts) and (rule[1] in known_facts):
                    known_facts.append(rules_changed.pop(rules_changed.index(rule))[2])
        rules = rules_changed   # aktualizujeme pravidla, protoze nejaka mohla byt odebrana
    vysvetlovaci_modul.print_result(known_facts)
