"""
Description: Tento modul ukládá a poskytuje znalosti.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.12.2023
"""
from baze_dat import *


class Node:
    # trida reprezentujici uzel and/or grafu
    def __init__(self, name, type, children):
        """
        Konstruktor uzlu
        :param name: jmeno pokrmu ci ingredience
        :param type: typ uzlu, budto "and", "or", "="
        :param children: seznam potomku uzlu
        """
        self.name = name
        self.type = type
        self.children = children


# vytvoreni uzlu pro popsani slozeni jednotlivych jidel
minced_meat = Node(basic_ingredients[0], "", [])
onion = Node(basic_ingredients[1], "", [])
sauce_tomato = Node(sauces[0], "", [])

spaghetti = Node(pasta[0], "", [])
green_lasagne = Node(pasta[1], "", [])

sauce_napoli = Node(sauces[2], "", [])

sauce_color_red = Node(sauce_color[0], "=", [sauce_tomato])
sauce_bolognese = Node(sauces[1], "and", [minced_meat, onion, sauce_color_red])

lasagne_verde = Node(dishes[0], "and", [green_lasagne, sauce_bolognese])
spaghetti_bolognese = Node(dishes[1], "and", [spaghetti, sauce_bolognese])
spaghetti_napoli = Node(dishes[2], "and", [spaghetti, sauce_napoli])

dishes = Node("pokrmy", "or", [lasagne_verde, spaghetti_bolognese, spaghetti_napoli])
