"""
Description: Tento modul řídí běh znalostního systému.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.12.2023
"""
import baze_znalosti
import komunikacni_modul
import vysvetlovaci_modul


def start():
    # tato metoda spousti znalostni system
    komunikacni_modul.start_info()
    main_loop()


def main_loop():
    # hlavni smycka programu
    run = True
    while run:
        choice = komunikacni_modul.choices()    # vypiseme moznosti a ziskame od uzivatele vstup
        komunikacni_modul.divider()
        match choice:
            case "1":
                selected = baze_znalosti.dishes     # nastavi se aktualni node na root node
                while True:
                    vysvetlovaci_modul.print_children(selected)     # vypise ingredience vybraneho pokrmu
                    komunikacni_modul.back_choice(len(selected.children))
                    c = int(komunikacni_modul.choice()) - 1
                    if c == len(selected.children):
                        # pokud se c == delce seznamu potomku, zvolil uzivatel moznost zpet
                        break
                    selected = selected.children[c]
                    if len(selected.children) < 1:
                        # jedna se o zakladni ingredienci protoze nema potomky
                        komunikacni_modul.elementary_ing()
                        break

            case "2":
                vysvetlovaci_modul.print_tree(baze_znalosti.dishes) # vypiseme cely and/or graf
            case "3":
                run = False # ukonci program
            case _:
                komunikacni_modul.input_error() # defaultni case pro chybny vstup
