"""
Description: Tento modul slouží k dodání informací uživateli pokud si o ně zažádá.
Author: Václav Ovsík, ovsikv@students.zcu.cz
Version: 1.0
Date: 13.12.2023
"""


def print_children(node):
    """
    Vypise potomky zadaneho nodu.
    :param node: zadany node
    """
    for i, child in enumerate(node.children):
        print(str(i+1) + ". " + child.name)


def print_tree(node, level=0, prefix="", last_sibling=True):
    """
    Vypise and or graf zacinajici ze zadaneho nodu.
    :param node: node ze ktereho chceme zacit vypisovat graf
    :param level: na jakem levelu aktualne jsme, ovlivnuje vypisi
    :param prefix: velikost mezery pred
    :param last_sibling: True pokud je tento node posledni v aktualnim seznamu potomku
    """
    if node is None:
        return
    if node.type == "":
        # pokud nema aktualni node zadne potomky
        print(" " * (level * 4) + prefix + ("└── " if last_sibling else "├── ") + node.name)
    else:
        # pokud ma aktualni node potomky
        print(" " * (level * 4) + prefix + (
            "└── " if last_sibling else "├── ") + node.name + "(" + node.type + ")")
        for child in node.children:
            # rekurzivne volame pro kazdeho potomka
            print_tree(child, level + 1, " " * 4, child == node.children[-1])
