"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-12-21
Program: Inferencni modul
Verze: 1.0.0
"""

# permutace
from itertools import permutations
# komunikacni modul
import komunikacni_modul as km
# vysvetlovaci modul
import vysvetlovaci_modul as vm
# baze znalosti
import baze_znalosti as bz
# baze dat
import baze_dat as bd


# start programu
def spustit():
    # vypise uvod
    km.vypis_uvod()
    # vypise pravidla
    km.vypis_pravidla()
    # vypise zpravu pro uzivatele
    km.vypis_zpravu()
    # vyresi a vypise reseni
    km.odpoved(vyres())
    # vypise konec
    km.vypis_konec()


# vyresi ulohu a vrati reseni
def vyres():
    reseni = []
    # permutace barev
    barvy = list(permutations(bd.barvy, len(bd.barvy)))
    # permutace narodnosti
    narodnosti = list(permutations(bd.narodnosti, len(bd.narodnosti)))
    # permutace cigaret
    cigarety = list(permutations(bd.cigarety, len(bd.cigarety)))
    # permutace napoju
    napoje = list(permutations(bd.napoje, len(bd.napoje)))
    # permutace zvirat
    zvirata = list(permutations(bd.zvirata, len(bd.zvirata)))
    for barva in barvy:
        # pouze permutace, ktere splnuji pravidla
        if bz.pravidla_barvy(barva):
            for narodnost in narodnosti:
                # pouze permutace, ktere splnuji pravidla
                if bz.pravidla_narodnosti(barva, narodnost):
                    for cigareta in cigarety:
                        # pouze permutace, ktere splnuji pravidla
                        if bz.pravidla_cigarety(barva, narodnost, cigareta):
                            for napoj in napoje:
                                # pouze permutace, ktere splnuji pravidla
                                if bz.pravidla_napoje(barva, narodnost, cigareta, napoj):
                                    for zvire in zvirata:
                                        # pouze permutace, ktere splnuji pravidla
                                        if bz.pravidla_zvirata(barva, narodnost, cigareta, napoj, zvire):
                                            # ulozi reseni
                                            reseni.append([barva, narodnost, cigareta, napoj, zvire])
    # vrati reseni
    return vm.vytvor_odpoved(reseni)
