"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-12-23
Program: Inferencni modul
Verze: 1.0.0
"""

# baze dat
import baze_dat as bd
# baze znalosti
import baze_znalosti as bz
# komunikacni modul
import komunikacni_modul as km
# vysvetlovaci modul
import vysvetlovaci_modul as vm


# zacetek programu
def spustit():
    # vypise uvod
    km.vypis_uvod()
    # vypise suroviny
    km.dostupne_suroviny()

    pokracuj = True

    while pokracuj:
        # vypise prikazy a pozada o zadani prikazu
        prikaz = km.zadej_prikaz()
        # lasagne verde
        if prikaz == "1":
            km.odpoved(lasagne_verde())
        # bolonske spagety
        elif prikaz == "2":
            km.odpoved(bolonske_spagety())
        # neapolske spagety
        elif prikaz == "3":
            km.odpoved(neapolske_spagety())
        # konec
        elif prikaz == "k":
            pokracuj = False
        # spatny prikaz
        else:
            km.spatny_format()

    # vypise konec
    km.konec()


# resi lasagne verde
def lasagne_verde():
    # zjisti jestli pokrm uz neni uvareny
    uvarit = "lasagne verde" in bd.data["pokrm"]
    # pokud ne
    if not uvarit:
        # pokusi se uvarit pokrm
        uvarit = bz.lasagne_verde(bd.data)
    # vypise vysledek
    return vm.lasagne_verde(uvarit)


# resi bolonske spagety
def bolonske_spagety():
    # zjisti jestli pokrm uz neni uvareny
    uvarit = "boloňské špagety" in bd.data["pokrm"]
    # pokud ne
    if not uvarit:
        # pokusi se uvarit pokrm
        uvarit = bz.bolonske_spagety(bd.data)
    # vypise vysledek
    return vm.bolonske_spagety(uvarit)


# resi neapolske spagety
def neapolske_spagety():
    # zjisti jestli pokrm uz neni uvareny
    uvarit = "neapolské špagety" in bd.data["pokrm"]
    # pokud ne
    if not uvarit:
        # pokusi se uvarit pokrm
        uvarit = bz.neapolske_spagety(bd.data)
    # vypise vysledek
    return vm.neapolske_spagety(uvarit)
