# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 1. 12. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Umoznuje zjistit, jestli domy s urcitymi vlastnostmi splnuji zadani ulohy.
# ------------------------------------------------------------------------------------------------
from baze_dat import *


# Pravidlo rikajici, jestli domy s urcitymi vlastnostmi (ne vsechny musi byt vyplneny)
# splnuji pozadavky, ktere uloha uklada.
def domy_splnuji_pozadavky(domy):
    # ocekava domy jako seznam objektu "Dum" o delce 5
    umisteni_domu = 1   # prvni zleva, postupne zvysujeme
    for dum in domy:
        # vzdy zjistime, jestli je jeste vlastnost nevyplnena (None) nebo vyplnena spravne
        # pokud neni vlastnost nastavena na None a obsahuje nespravnou hodnotu, mezivypocet nesplnuje pozadavky
        if dum.narodnost == NARODNOST_ANGLICANE:
            # Anglicane ziji v cervenem dome
            if dum.barva is not None and dum.barva != BARVA_CERVENA:
                return False
        elif dum.narodnost == NARODNOST_SPANELE:
            # Spanele maji psa
            if dum.zvire is not None and dum.zvire != ZVIRE_PES:
                return False
        elif dum.narodnost == NARODNOST_NOROVE:
            # Norove ziji v prvem dome zleva
            if umisteni_domu != 1:
                return False
            # Norove ziji v modrem domu
            if dum.barva is not None and dum.barva != BARVA_MODRA:
                return False
        elif dum.narodnost == NARODNOST_UKRAJINCI:
            # Ukrajinci piji caj
            if dum.piti is not None and dum.piti != PITI_CAJ:
                return False
        elif dum.narodnost == NARODNOST_JAPONCI:
            # Japonci kouri cigarety znacky Parliaments
            if dum.cigarety is not None and dum.cigarety != CIGARETY_PARLIAMENTS:
                return False

        if dum.cigarety == CIGARETY_SPARTY:
            # Obyvatele zluteho domu kouri sparty
            if dum.barva is not None and dum.barva != BARVA_ZLUTA:
                return False
            # V dome vedle domu s konem se kouri sparty
            splnitelne = False
            if umisteni_domu > 1:
                dum_vlevo = domy[umisteni_domu - 2]
                if dum_vlevo.zvire is None or dum_vlevo.zvire == ZVIRE_KUN:
                    splnitelne = True
            if not splnitelne and umisteni_domu < 5:
                dum_vpravo = domy[umisteni_domu]
                if dum_vpravo.zvire is None or dum_vpravo.zvire == ZVIRE_KUN:
                    splnitelne = True
            if not splnitelne:
                return False
        elif dum.cigarety == CIGARETY_CHESTERFIELDKY:
            # Muz, ktery kouri Chesterfieldky, zije v dome vedle domu rodiny, ktera chova lisku
            splnitelne = False
            if umisteni_domu > 1:
                dum_vlevo = domy[umisteni_domu - 2]
                if dum_vlevo.zvire is None or dum_vlevo.zvire == ZVIRE_LISKA:
                    splnitelne = True
            if not splnitelne and umisteni_domu < 5:
                dum_vpravo = domy[umisteni_domu]
                if dum_vpravo.zvire is None or dum_vpravo.zvire == ZVIRE_LISKA:
                    splnitelne = True
            if not splnitelne:
                return False
        elif dum.cigarety == CIGARETY_WINSTONKY:
            # Kurak Winstonek pestuje sneky
            if dum.zvire is not None and dum.zvire != ZVIRE_SNECI:
                return False
        elif dum.cigarety == CIGARETY_LUCKY_STRIKE:
            # Kurak Lucky-Strike pije pomerancovy dzus
            if dum.piti is not None and dum.piti != PITI_POMERANCOVY_DZUS:
                return False

        if dum.barva == BARVA_ZELENA:
            # V zelenem dome piji kavu
            if dum.piti is not None and dum.piti != PITI_KAVA:
                return False
            # Zeleny dum je bezprostredne napravo od bileho domu
            if umisteni_domu == 1 or (domy[umisteni_domu-2].barva is not None
                                      and domy[umisteni_domu-2].barva != BARVA_BILA):
                return False

        if umisteni_domu == 3:
            # V prostrednim domu piji mleko
            if dum.piti is not None and dum.piti != PITI_MLEKO:
                return False

        umisteni_domu += 1

    return True
