# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 1. 12. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Zjisti vsechny varianty vlastnosti prirazenych k dumum, ktere splnuji zadani.
# ------------------------------------------------------------------------------------------------
import copy

from baze_dat import *
import baze_znalosti

import komunikacni_modul

# Spusti program.
def spust_program():
    komunikacni_modul.vypis_uvod()
    pridej_domum_hodnoty(domy, nepouzite_data)


# Priradi domum hodnoty - pokud jsme nalezli reseni, necha ho rovnou vypsat.
# Najde vsechny reseni pro aktualni vlastnosti domu, pripadne,
# pokud je vlastnost nastavena na 'None', znamena to, ze jeste nebyla definovana jeji hodnota.
def pridej_domum_hodnoty(domy, k_pridani):
    # provadime hloubkovou kopii, jelikoz pouzivame
    # rekurzi a mohlo by se jinak stat, ze zmenime data
    # volajici funkci "pod rukama"
    nove_k_pridani = copy.deepcopy(k_pridani)
    # pokud jeste nejsou pouzity vsechny narodnosti,
    # zkusime pro vsechny domy, ktere jeste nemaji narodnost
    # prirazenou priradit prvni zbyvajici, pokud se tim neporusi
    # pravidla ulohy, budeme pak rekurzivne postupovat - takto
    # stejne pote budeme prirazovat i dalsi vlastnosti
    if len(k_pridani.narodnosti) != 0:
        narodnost_k_pridani = nove_k_pridani.narodnosti[0]
        del nove_k_pridani.narodnosti[0]
        for i in range(len(domy)):
            if domy[i].narodnost is not None:
                # vlastnost je jiz nastavena
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].narodnost = narodnost_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                pridej_domum_hodnoty(kopie_domu, nove_k_pridani)
    elif len(k_pridani.cigarety) != 0:
        cigarety_k_pridani = nove_k_pridani.cigarety[0]
        del nove_k_pridani.cigarety[0]
        for i in range(len(domy)):
            if domy[i].cigarety is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].cigarety = cigarety_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                pridej_domum_hodnoty(kopie_domu, nove_k_pridani)
    elif len(k_pridani.piti) != 0:
        piti_k_pridani = nove_k_pridani.piti[0]
        del nove_k_pridani.piti[0]
        for i in range(len(domy)):
            if domy[i].piti is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].piti = piti_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                pridej_domum_hodnoty(kopie_domu, nove_k_pridani)
    elif len(k_pridani.barvy) != 0:
        barva_k_pridani = nove_k_pridani.barvy[0]
        del nove_k_pridani.barvy[0]
        for i in range(len(domy)):
            if domy[i].barva is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].barva = barva_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                pridej_domum_hodnoty(kopie_domu, nove_k_pridani)
    elif len(k_pridani.zvirata) != 0:
        zvire_k_pridani = nove_k_pridani.zvirata[0]
        del nove_k_pridani.zvirata[0]
        for i in range(len(domy)):
            if domy[i].zvire is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].zvire = zvire_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                pridej_domum_hodnoty(kopie_domu, nove_k_pridani)
    else:
        # uz jsou prirazeny uplne vsechny hodnoty,
        # to znamena, ze jsme splnili pravidla a nasli vysledek
        komunikacni_modul.vypis_vysledek(domy)
