# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 1. 12. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Vysvetlovaci modul vysvetluje vysledky, ke kterym dosel inferencni modul uzivateli.
# V nasem pripade tyto vysledky zobrazuje v graficke podobe.
# ------------------------------------------------------------------------------------------------
from graficka_knihovna import graphics
from baze_dat import *


# Zobrazi na GUI nalezeny strom (AND-OR graf).
# Parametr prvek je korenem stromu.
def vypis_strom(prvek):
    okno = graphics.GraphWin("Graf", 1200, 1000)
    zobraz_podstrom(prvek, okno)
    try:
        okno.getKey()
        okno.close()
    except Exception as e:
        # pokud zavrete okno krizkem, je vyhozena vyjimka,
        # na tu ale neni treba reagovat, jen je odchycena a program bezi dal
        pass


# Zobrazi podstrom v urcitem okne na urcite pozici [x, y],
# coz jsou souradnice od leveho horniho rohu. Pokud se nejedna
# o list stromu, ale uzel ma nejake potomky, zavola se nad nimi rekurzivne,
# cimz tyto potomky take vykresli.
def zobraz_podstrom(prvek, okno, pozice=[600, 40]):
    okno.setBackground(graphics.color_rgb(255, 255, 255))
    bod = graphics.Point(pozice[0], pozice[1])
    text = prvek if not isinstance(prvek, list) else prvek[0]
    uzel = graphics.Text(bod, text.replace(" ", "\n"))
    if isinstance(prvek, list):
        mnozstvi_potomku = prvek[2]
        i = -20*prvek[2]
        if mnozstvi_potomku == 1:
            i = 0
        # nasledujici and_znazorneni slouzi k
        # nakresleni "cary" mezi hrany, ktera znazornuje,
        # ze se jedna o and vztah, nikoliv o or vztah mezi potomky
        prvni_bod_and_znazorneni = None
        posledni_bod_and_znazorneni = None
        for potomek in prvek[3:]:
            # nejakym zpusobem upravime nove pozice, na kterych bude vykreslen potomek
            nova_pozice = [pozice[0]+i, pozice[1]+100]
            pozice_usecka = [(pozice[0]-nova_pozice[0])*0.8+nova_pozice[0], (pozice[1]-nova_pozice[1])*0.8+nova_pozice[1]]
            # ziskame bod, ze ktereho vede "cara" znazornujici and vztah
            posledni_bod_and_znazorneni = [(pozice[0]-nova_pozice[0])*0.75+nova_pozice[0], (pozice[1]-nova_pozice[1])*0.75+nova_pozice[1]]
            if prvni_bod_and_znazorneni is None:
                prvni_bod_and_znazorneni = posledni_bod_and_znazorneni
            nova_pozice_usecka = [(nova_pozice[0]-pozice[0])*0.8+pozice[0], (nova_pozice[1]-pozice[1])*0.8 + pozice[1]]
            usecka = graphics.Line(graphics.Point(pozice_usecka[0], pozice_usecka[1]),
                                   graphics.Point(nova_pozice_usecka[0], nova_pozice_usecka[1]))
            usecka.draw(okno)
            zobraz_podstrom(potomek, okno, nova_pozice)
            potomku_zpracovano = 1
            if isinstance(potomek, list):
                potomku_zpracovano += potomek[2]
            if mnozstvi_potomku != 1:
                i += potomku_zpracovano * ((40*prvek[2])/(mnozstvi_potomku-1)) + 20

        if len(prvek) > 4 and prvek[1] == VAZBA_AND:
            # bude vykreslena usecka znazornujici vazbu AND
            usecka = graphics.Line(graphics.Point(prvni_bod_and_znazorneni[0], prvni_bod_and_znazorneni[1]),
                                   graphics.Point(posledni_bod_and_znazorneni[0], posledni_bod_and_znazorneni[1]))
            usecka.draw(okno)
    uzel.draw(okno)
