# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 1. 12. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Inferencni modul na zaklade znamych faktu a pravidel odvozuje dalsi fakta,
# cimz postupne ziska vysledek.
# ------------------------------------------------------------------------------------------------
from random import *

import komunikacni_modul
from baze_znalosti import *


# Spusti program.
def spust_program():
    komunikacni_modul.vypis_uvod()
    vysledek = aplikuj_pravidla(data, pravidla)[0]
    komunikacni_modul.vypis_vysledek(vysledek)


# Pro urcita data (aktualne zname fakty) a pravidla, ktere je stale mozne aplikovat
# aplikuje pravidla tak dlouho, dokud nedojde k vysledku.
def aplikuj_pravidla(data, pravidla):
    if len(data) == 1:
        # jiz se nam podarilo zjednodusit fakta na jediny vyraz
        return data
    aplikovatelna_pravidla = ziskej_pouzitelna_pravidla(data, pravidla)
    # vybereme jedno pravidlo nahodne
    index = 0 if len(aplikovatelna_pravidla) == 0 else randint(0, len(aplikovatelna_pravidla)-1)
    pravidlo = pravidla[index]
    # aplikujeme jedno pravidlo a rekurzivne zavolame aplikuj_pravidla
    data = aplikuj_pravidlo(data, pravidlo)
    pravidla.remove(pravidlo)
    return aplikuj_pravidla(data, pravidla)


# Aplikuje jedine pravidlo na zname fakta.
def aplikuj_pravidlo(data, pravidlo):
    # odstranime stare fakta
    for hodnota in pravidlo.puvodni_vyrazy:
        data.remove(hodnota)
    # pridame novy fakt
    data.append(pravidlo.novy_vyraz)
    return data


# Vrati vsechna pravidla, ktera jsou momentalne aplikovatelna
# na zname fakta.
def ziskej_pouzitelna_pravidla(data, pravidla):
    k_vraceni = []
    for pravidlo in pravidla:
        je_aplikovatelne = True
        for prvek in pravidlo.puvodni_vyrazy:
            if prvek not in data:
                je_aplikovatelne = False
                break
        if je_aplikovatelne:
            k_vraceni.append(pravidlo)

    return k_vraceni
