# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 1. 12. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul obsahuje znalosti - dokaze zjistit,
# jestli urcitym zpusobem namapovane vlastnosti na domy splnuji pozadavky v zadani.
# ------------------------------------------------------------------------------------------------
from baze_dat import *


# pravidlo rikajici, jestli domy s urcitymi vlastnostmi (ne vsechny musi byt vyplneny)
# splnuji pozadavky, ktere uloha uklada.
def domy_splnuji_pozadavky(domy):
    # ocekava domy jako seznam objektu "Dum" o delce 5
    umisteni_domu = 1   # prvni zleva, postupne zvysujeme
    for dum in domy:
        if dum.narodnost == NARODNOST_ANGLICAN:
            # Anglican zije v cervenem dome.
            if dum.barva is not None and dum.barva != BARVA_CERVENA:
                return False
        elif dum.narodnost == NARODNOST_SVED:
            # Sved chova psy.
            if dum.zvire is not None and dum.zvire != ZVIRATA_PSI:
                return False
        elif dum.narodnost == NARODNOST_DAN:
            # Dan pije caj.
            if dum.piti is not None and dum.piti != PITI_CAJ:
                return False
        elif dum.narodnost == NARODNOST_NOR:
            # Nor zije v prvnim dome.
            if umisteni_domu != 1:
                return False
            # Nor zije vedle modreho domu.
            splnitelne = False
            if umisteni_domu > 1 and (domy[umisteni_domu-2].barva is None or domy[umisteni_domu-2].barva == BARVA_MODRA):
                splnitelne = True
            elif umisteni_domu < 5 and (domy[umisteni_domu].barva is None or domy[umisteni_domu].barva == BARVA_MODRA):
                splnitelne = True
            if not splnitelne:
                return False
        elif dum.narodnost == NARODNOST_NEMEC:
            # Nemec kouri Prince.
            if dum.cigarety is not None and dum.cigarety != CIGARETY_PRINCE:
                return False

        if dum.cigarety == CIGARETY_DUNHILL:
            # Obyvatel zluteho domu kouri Dunhill.
            if dum.barva is not None and dum.barva != BARVA_ZLUTA:
                return False
            # Ten, co chova kone, zije vedle toho, co kouri Dunhill.
            splnitelne = False
            if umisteni_domu > 1 and (
                    domy[umisteni_domu - 2].zvire is None or domy[umisteni_domu - 2].zvire == ZVIRATA_KONE):
                splnitelne = True
            elif umisteni_domu < 5 and (domy[umisteni_domu].zvire is None or domy[umisteni_domu].zvire == ZVIRATA_KONE):
                splnitelne = True
            if not splnitelne:
                return False
        elif dum.cigarety == CIGARETY_PALL_MALL:
            # Ten, co kouri Pall Mall, chova ptaky.
            if dum.zvire is not None and dum.zvire != ZVIRATA_PTACI:
                return False
        elif dum.cigarety == CIGARETY_BLEND:
            # Ten, co kouri Blend, zije vedle toho, co chova kocky.
            splnitelne = False
            if umisteni_domu > 1 and (
                    domy[umisteni_domu - 2].zvire is None or domy[umisteni_domu - 2].zvire == ZVIRATA_KOCKY):
                splnitelne = True
            elif umisteni_domu < 5 and (domy[umisteni_domu].zvire is None or domy[umisteni_domu].zvire == ZVIRATA_KOCKY):
                splnitelne = True
            if not splnitelne:
                return False
            # Ten, co kouri Blend, ma souseda, ktery pije vodu.
            splnitelne = False
            if umisteni_domu > 1 and (
                    domy[umisteni_domu - 2].piti is None or domy[umisteni_domu - 2].piti == PITI_VODA):
                splnitelne = True
            elif umisteni_domu < 5 and (
                    domy[umisteni_domu].piti is None or domy[umisteni_domu].piti == PITI_VODA):
                splnitelne = True
            if not splnitelne:
                return False
        elif dum.cigarety == CIGARETY_BLUE_MASTER:
            # Ten, co kouri Blue Master, pije pivo.
            if dum.piti is not None and dum.piti != PITI_PIVO:
                return False

        if dum.piti == PITI_KAVA:
            # Obyvatel zeleneho domu pije kavu.
            if dum.barva is not None and dum.barva != BARVA_ZELENA:
                return False
        elif dum.piti == PITI_MLEKO:
            # Ten, co zije ve strednim dome, pije mleko.
            if umisteni_domu != 3:
                return False

        if dum.barva == BARVA_ZELENA:
            # Zeleny dum je hned vedle bileho domu na leve strane.
            if umisteni_domu == 5 or (domy[umisteni_domu].barva is not None
                                      and domy[umisteni_domu].barva != BARVA_BILA):
                return False

        umisteni_domu += 1

    return True
