# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 1. 12. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul zjisti vysledek Einsteinovy ulohy.
# Priradi vzdy domu jednu ze zbyvajicich hodnot a zjisti,
# jestli takto vznikla kombinace domu splnuje zadani. Pokud ano,
# pokracuje rekurzivne, priradi tedy nejakemu domu opet jednu ze zbyvajicich
# hodnot, v opacnem pripade vrati operaci zpet a zkusi priradit jinou hodnotu.
# ------------------------------------------------------------------------------------------------
import copy

from baze_dat import *
import baze_znalosti
import komunikacni_modul


# Spusti program.
def spust_program():
    komunikacni_modul.vypis_uvod()
    pridej_domum_hodnoty(domy, nepouzite_data)


# Prida domum hodnoty, ktere splnuji pozadavky
# stanovene zadanim. Postupuje tak, ze prida jednomu domu
# jednu hodnotu, pokud by vsak tato operace znamenala,
# ze prestane splnovat zadani, vrati operaci zpet.
# Pak opet resi rekurzivne ukol priradit jednu hodnotu jednomu domu.
def pridej_domum_hodnoty(domy, k_pridani):
    # provadime hloubkove kopie, abychom si nemenili
    # informace "pod rukama"
    nove_k_pridani = copy.deepcopy(k_pridani)
    if len(k_pridani.narodnosti) != 0:
        narodnost_k_pridani = nove_k_pridani.narodnosti[0]
        del nove_k_pridani.narodnosti[0]
        # pro kazdy dum, ve kterem jeste neni urcena narodnost,
        # zkusime pridat narodnost_k_pridani, a pokud splnuje
        # nove vznikla kombinace pozadavky, rekurzivne se zavolame
        # - takto se postupuje i pro cigarety, piti a ostatni
        for i in range(len(domy)):
            if domy[i].narodnost is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].narodnost = narodnost_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                if pridej_domum_hodnoty(kopie_domu, nove_k_pridani):
                    return True
    elif len(k_pridani.cigarety) != 0:
        cigarety_k_pridani = nove_k_pridani.cigarety[0]
        del nove_k_pridani.cigarety[0]
        for i in range(len(domy)):
            if domy[i].cigarety is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].cigarety = cigarety_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                if pridej_domum_hodnoty(kopie_domu, nove_k_pridani):
                    return True
    elif len(k_pridani.piti) != 0:
        piti_k_pridani = nove_k_pridani.piti[0]
        del nove_k_pridani.piti[0]
        for i in range(len(domy)):
            if domy[i].piti is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].piti = piti_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                if pridej_domum_hodnoty(kopie_domu, nove_k_pridani):
                    return True
    elif len(k_pridani.barvy) != 0:
        barva_k_pridani = nove_k_pridani.barvy[0]
        del nove_k_pridani.barvy[0]
        for i in range(len(domy)):
            if domy[i].barva is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].barva = barva_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                if pridej_domum_hodnoty(kopie_domu, nove_k_pridani):
                    return True
    elif len(k_pridani.zvirata) != 0:
        zvire_k_pridani = nove_k_pridani.zvirata[0]
        del nove_k_pridani.zvirata[0]
        for i in range(len(domy)):
            if domy[i].zvire is not None:
                continue
            kopie_domu = copy.deepcopy(domy)
            kopie_domu[i].zvire = zvire_k_pridani
            if baze_znalosti.domy_splnuji_pozadavky(kopie_domu):
                if pridej_domum_hodnoty(kopie_domu, nove_k_pridani):
                    return True
    else:
        # uz jsme vycerpali vsechny hodnoty k prirazeni,
        # tudiz jsme nalezli vysledek
        komunikacni_modul.vypis_vysledek(domy)
        return True  # informace o tom, ze bychom meli skoncit, jelikoz uloha je jednoznacna
