"""
inferencni modul systemu
autor: Miroslav Martinek
datum: 14.12.2023
verze: 2.0
"""
import baze_znalosti
import komunikacni_modul
import baze_dat
import itertools
import vysvetlovaci_modul


# zkontroluje zda reseni splnuje vsechny pravidla
def kontrola(reseni):
    if(baze_znalosti.pravidlo01(reseni)):
        return False

    if (baze_znalosti.pravidlo02(reseni)):
        return False

    if (baze_znalosti.pravidlo03(reseni)):
        return False

    if (baze_znalosti.pravidlo04(reseni)):
        return False

    if (baze_znalosti.pravidlo05(reseni)):
        return False

    if (baze_znalosti.pravidlo06(reseni)):
        return False

    if (baze_znalosti.pravidlo07(reseni)):
        return False

    if (baze_znalosti.pravidlo08(reseni)):
        return False

    if (baze_znalosti.pravidlo09(reseni)):
        return False

    if (baze_znalosti.pravidlo10(reseni)):
        return False

    if (baze_znalosti.pravidlo11(reseni)):
        return False

    if (baze_znalosti.pravidlo12(reseni)):
        return False

    if (baze_znalosti.pravidlo13(reseni)):
        return False

    if (baze_znalosti.pravidlo14(reseni)):
        return False

    return True


# resi hadanku
def res_hadanku():
    # vypisy informaci
    komunikacni_modul.uvod()
    komunikacni_modul.pravidla()

    # vytvari permutace a odfiltrovava nektere jiste neuzetecne moznosti (vyrazne zrychleni)
    moznosti_barvy = list(itertools.permutations(baze_dat.barvy))
    moznosti_barvy[:] = [x for x in moznosti_barvy if x[0] == "modra"]  # Norove jsou v dome 0 + Norove jsou v modrem dome
    moznosti_barvy[:] = [x for x in moznosti_barvy if x.index("bila") == (x.index("zelena") - 1)]  # zeleny dum je na bezprostredne naprovo od bileho
    moznosti_narod = list(itertools.permutations(baze_dat.narodnosti))
    moznosti_narod[:] = [x for x in moznosti_narod if x[0] == "Norove"]  # Norove jsou v dome 0
    moznosti_napoje = list(itertools.permutations(baze_dat.napoje))
    moznosti_napoje[:] = [x for x in moznosti_napoje if x[2] == "mleko"]  # v prostrednim dome piji mleko
    moznosti_cigarety = list(itertools.permutations(baze_dat.cigarety))
    moznosti_zvirata = list(itertools.permutations(baze_dat.zvirata))

    counter = 1
    # vytvareni potencialnich reseni
    for barvy in moznosti_barvy:
        for narodnosti in moznosti_narod:
            if(baze_znalosti.pravidlo01_prubezne(barvy,narodnosti)):  # prubezna kontrola pravidla 1 pro zrychleni
                continue
            for napoje in moznosti_napoje:
                if(baze_znalosti.pravidlo09_prubezne(napoje,narodnosti)):  # prubezna kontrola pravidla 9 pro zrychleni
                    continue
                for cigarety in moznosti_cigarety:
                    for zvirata in moznosti_zvirata:
                        reseni = []
                        for x in range(0, 5):
                            reseni.append(
                                [barvy[x], narodnosti[x], napoje[x], cigarety[x], zvirata[x]]
                            )
                        if(kontrola(reseni)):
                            vysvetlovaci_modul.tabulka(
                                reseni, counter, zvirata.index("zebra") + 1, napoje.index("voda") + 1)  # zkontrolovane reseni vypisem
                            counter += 1
